//  File:        IConfigurator.java
//  Copyright:   Copyright (C) 2014 AL ENGINEERING AG. All rights reserved.
//  Website:     http://www.al-ag.de
//  Description:
//  Comments:
//  Author:      AL ENGINEERING AG
//  E-mail:      info@al-ag.de
//
//   This file is part of d(((eti-API.
//
//   d(((eti-API is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   d(((eti-API is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; If not, see <http://www.gnu.org/licenses/> or
//   write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//   Boston, MA 02111-1307 USA.
package de.alag.eticket.ticketinfo;

import de.alag.eticket.data.efm.IEfmXmlParser;
import de.alag.vdv.ka.service.ICodeInterpreter;
import de.alag.vdv.ka.service.IOrganisationInterpreter;
import de.alag.vdv.ka.service.IOrtInterpreter;
import de.alag.vdv.ka.service.IServicekennungInterpreter;
import de.alag.vdv.ka.tlv.global.EfmProduktID;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

/**
 *
 * @author Alexander Schuetz
 */
public interface IConfigurator {
    void storeConfiguration(Properties config);
    Properties loadConfiguration();
    Map<String, Set<EfmProduktID>> getWebTemplates();
    IEfmXmlParser getParser();
    ICodeInterpreter getCodeInterpreter();
    IOrganisationInterpreter getOrganisationInterpreter();
    IOrtInterpreter getOrtInterpreter();
    IServicekennungInterpreter getServicekennungInterpreter();
    boolean isLocalConfig();
}
