//  File:        LoadkeyDialog.java
//  Copyright:   Copyright (C) 2010 AL ENGINEERING AG. All rights reserved.
//  Website:     http://www.al-ag.de
//  Description:
//  Comments:
//  Last edit:   18.06.2013
//  Author:      AL ENGINEERING AG
//  E-mail:      info@al-ag.de
//
//   This file is part of d(((eti-API.
//
//   d(((eti-API is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   d(((eti-API is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; If not, see <http://www.gnu.org/licenses/> or
//   write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//   Boston, MA 02111-1307 USA.
package de.alag.eticket.ticketinfo;

import de.alag.util.Converters;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;
import de.alag.vdv.ka.cv.CVCertPKCS;
import de.alag.vdv.ka.nfc.ISAM;

/**
 *
 * @author Alexander Schuetz
 */
public class LoadkeyDialog extends javax.swing.JDialog {

    private ISAM sam;
    
    /**
     * Creates new form LoadkeyDialog
     */
    public LoadkeyDialog(java.awt.Frame parent, boolean modal, ISAM sam) {
        super(parent, modal);
        initComponents();
        this.sam = sam;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        actKeyFileChooser = new javax.swing.JFileChooser();
        loadKeyButton = new javax.swing.JButton();
        keyPathTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        abortButton = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        loadButton = new javax.swing.JButton();
        caPathTextField = new javax.swing.JTextField();
        sigPathTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();

        actKeyFileChooser.setDialogTitle("Aktivierungsschlüssel laden");

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(304, 198));
        setResizable(false);

        loadKeyButton.setText("Öffnen");
        loadKeyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadKeyButtonActionPerformed(evt);
            }
        });

        keyPathTextField.setEditable(false);

        jLabel2.setText("Kryptogramm:");

        abortButton.setText("Abbrechen");
        abortButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                abortButtonActionPerformed(evt);
            }
        });

        loadButton.setText("Schlüssel laden");
        loadButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadButtonActionPerformed(evt);
            }
        });

        caPathTextField.setEditable(false);

        sigPathTextField.setEditable(false);

        jLabel3.setText("CA:");

        jLabel4.setText("SIG:");

        jCheckBox1.setSelected(true);
        jCheckBox1.setText("Eigener Schlüssel");
        jCheckBox1.setToolTipText("<html>\n<p>Diese Option muss gewählt werden für das Verwalten eines eigenen<br>\nSchlüssels durch eine Instanz des Hintergrundsystems.</p><hr>\n<p>Für das Löschen eines beliebigen Schlüssels  durch das Security Management<br>\n(zuständig für das gesamte System) muss diese Option abgewählt werden.</p>\n</html>");

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("<html>\n<strong>d<font color=#009de0>(((e</font>ti</strong> - Loadkey\n</html>");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.TRAILING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jSeparator2)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addGap(0, 0, Short.MAX_VALUE)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(loadKeyButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addComponent(jLabel2)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(keyPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 212, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addComponent(jLabel3)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(caPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 212, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addComponent(jLabel4)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(sigPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 212, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(loadButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(abortButton)
                        .addGap(14, 14, 14))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jCheckBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(9, 9, 9)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(loadKeyButton)
                    .addComponent(jCheckBox1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(keyPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(caPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(sigPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(loadButton)
                    .addComponent(abortButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void loadKeyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadKeyButtonActionPerformed
        final String fileName = sam.getLoadKeyFileName() + ".cry";
        FileFilter filter = new FileFilter() {

            @Override
            public boolean accept(File f) {
                if (f != null && f.exists() && f.isDirectory()) {
                    return true;
                }
                return f != null && f.exists() && f.canRead() && f.isFile() && fileName.equalsIgnoreCase(f.getName());
            }

            @Override
            public String getDescription() {
                return "Schlüsselkryptogramm (" + fileName + ")";
            }
        };
        
        FileFilter[] filters = actKeyFileChooser.getChoosableFileFilters();
        for (FileFilter ff : filters) {
            actKeyFileChooser.removeChoosableFileFilter(ff);
        }
        actKeyFileChooser.addChoosableFileFilter(filter);
        actKeyFileChooser.setDialogTitle(fileName);
        int result = actKeyFileChooser.showOpenDialog(this);
        if (result == JFileChooser.APPROVE_OPTION) {
            String path = actKeyFileChooser.getSelectedFile().getAbsolutePath();
            keyPathTextField.setText(path);
            File ca = new File(path.replace(".cry", "_CA.cv"));
            if (ca.exists() && ca.canRead() && ca.isFile()) {
                caPathTextField.setText(ca.getAbsolutePath());
            } else {
                JOptionPane.showMessageDialog(null,
                        "Das CA-Zertifikat wurde nicht gefunden oder der Zugriff"
                        + " wurde verweigert!\n"
                        + "Die Datei \"" + ca.getName() + "\" muss sich im"
                        + " selben Verzeichnis wie das gewählte Kryprogramm"
                        + " befinden.\n", "Fehler",
                        JOptionPane.ERROR_MESSAGE);
                caPathTextField.setText("");
            }
            File sig = new File(path.replace(".cry", "_Sig.cv"));
            if (sig.exists() && sig.canRead() && sig.isFile()) {
                sigPathTextField.setText(sig.getAbsolutePath());
            } else {
                JOptionPane.showMessageDialog(null,
                        "Das CA-Zertifikat wurde nicht gefunden oder der Zugriff"
                        + " wurde verweigert!\n"
                        + "Die Datei \"" + sig.getName() + "\" muss sich im"
                        + " selben Verzeichnis wie das gewählte Kryprogramm"
                        + " befinden.\n", "Fehler",
                        JOptionPane.ERROR_MESSAGE);
                sigPathTextField.setText("");
            }
        }
        checkReady();
    }//GEN-LAST:event_loadKeyButtonActionPerformed

    private void abortButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_abortButtonActionPerformed
        this.dispose();
    }//GEN-LAST:event_abortButtonActionPerformed

    private void loadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadButtonActionPerformed
        CVCertPKCS ca = new CVCertPKCS();
        CVCertPKCS sig = new CVCertPKCS();
        try {
            FileInputStream fis = null;
            byte[] buffer = new byte[4096];
            fis = new FileInputStream(caPathTextField.getText());
            if (fis.read(buffer) > 0) {
                ca.unmarshal(buffer, 0);
            } else {
                ca = null;
            }
        } catch (IOException ex) {
            ca = null;
        }
        try
        {
            FileInputStream fis = null;
            byte[] buffer = new byte[4096];
            fis = new FileInputStream(sigPathTextField.getText());
            if (fis.read(buffer) > 0) {
                sig.unmarshal(buffer, 0);
            } else {
                sig = null;
            }
        } catch (IOException ex) {
            sig = null;
        }
        byte[] cry = null;
        try
        {
            FileReader fr = null;
            char[] buffer = new char[4096];
            fr = new FileReader(keyPathTextField.getText());
            int cryLength = fr.read(buffer);
            if (cryLength > 0) {
                String hexBuffer = new String(buffer, 0, cryLength);
                cry = Converters.getBytesFromHexString(hexBuffer);
            }
        } catch (IOException ex) {
            cry = null;
        }
        boolean ok = true;
        if (ca == null) {
            JOptionPane.showMessageDialog(null, "Fehler beim Laden des CA-Zertifikates!"
                    , "Fehler", JOptionPane.ERROR_MESSAGE);
            ok = false;
        }
        if (sig == null) {
            JOptionPane.showMessageDialog(null, "Fehler beim Laden des SIG-Zertifikates!"
                    , "Fehler", JOptionPane.ERROR_MESSAGE);
            ok = false;
        }
        if (cry == null) {
            JOptionPane.showMessageDialog(null, "Fehler beim Laden des Kryptogramms!"
                    , "Fehler", JOptionPane.ERROR_MESSAGE);
            ok = false;
        }
        if (ok) {
            ok = sam.loadSymKey(true, ca, sig, cry);
        }
        if (!ok) {
            JOptionPane.showMessageDialog(null, "Beim Einbringen des Kryptogramms "
                    + "in das SAM sind Fehler aufgetreten!\n\n"
                    + sam.getLastErrorString(), "Fehler", JOptionPane.ERROR_MESSAGE);
        } else {
            JOptionPane.showMessageDialog(null, "Das Kryptogramms wurde erfolgreich "
                    + "in das SAM eingebracht!", "Info", JOptionPane.INFORMATION_MESSAGE);
            this.dispose();
        }
    }//GEN-LAST:event_loadButtonActionPerformed

    private void checkReady() {
        if (keyPathTextField.getText() != null
                && !keyPathTextField.getText().isEmpty()
                && caPathTextField.getText() != null
                && !caPathTextField.getText().isEmpty()
                && sigPathTextField.getText() != null
                && !sigPathTextField.getText().isEmpty()) {
            loadButton.setEnabled(true);
        } else {
            loadButton.setEnabled(false);
        }
        
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton abortButton;
    private javax.swing.JFileChooser actKeyFileChooser;
    private javax.swing.JTextField caPathTextField;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JTextField keyPathTextField;
    private javax.swing.JButton loadButton;
    private javax.swing.JButton loadKeyButton;
    private javax.swing.JTextField sigPathTextField;
    // End of variables declaration//GEN-END:variables
}
