//  File:        PinDialog.java
//  Copyright:   Copyright (C) 2010 AL ENGINEERING AG. All rights reserved.
//  Website:     http://www.al-ag.de
//  Description:
//  Comments:
//  Last edit:   18.06.2013
//  Author:      AL ENGINEERING AG
//  E-mail:      info@al-ag.de
//
//   This file is part of d(((eti-API.
//
//   d(((eti-API is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   d(((eti-API is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; If not, see <http://www.gnu.org/licenses/> or
//   write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//   Boston, MA 02111-1307 USA.
package de.alag.eticket.ticketinfo;

import de.alag.vdv.ka.nfc.IKUM;

/**
 *
 * @author Alexander Schuetz
 */
public class PinDialog extends javax.swing.JDialog {

    private IKUM kum;
    private boolean pinOK = false;

    public boolean isPinOK() {
        return pinOK;
    }
    
    /**
     * Creates new form PinDialog
     */
    public PinDialog(java.awt.Frame parent, IKUM kum) {
        super(parent, true);
        initComponents();
        this.kum = kum;
        setLocationRelativeTo(parent);
        pinOK = false;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pinHeaderLabel1 = new javax.swing.JLabel();
        pinInfoLabel = new javax.swing.JLabel();
        pinLabel = new javax.swing.JLabel();
        pinPasswordField = new javax.swing.JPasswordField();
        pinOkButton = new javax.swing.JButton();
        pinAbbruchButton = new javax.swing.JButton();
        versucheLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Pineingabe");
        setAlwaysOnTop(true);
        setModal(true);
        setResizable(false);

        pinHeaderLabel1.setText("Bitte Pin Eingeben.");

        pinInfoLabel.setText("Mindestens 4 Ziffer, Maximal 12 Ziffern");

        pinLabel.setText("Pin:");

        pinOkButton.setText("Ok");
        pinOkButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pinOkButtonActionPerformed(evt);
            }
        });

        pinAbbruchButton.setText("Abbruch");
        pinAbbruchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pinAbbruchButtonActionPerformed(evt);
            }
        });

        versucheLabel.setForeground(new java.awt.Color(204, 0, 0));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(0, 23, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(pinOkButton, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(pinAbbruchButton, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addContainerGap())
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(pinHeaderLabel1)
                                    .addGroup(layout.createSequentialGroup()
                                        .addGap(17, 17, 17)
                                        .addComponent(pinLabel)
                                        .addGap(18, 18, 18)
                                        .addComponent(pinPasswordField, javax.swing.GroupLayout.PREFERRED_SIZE, 117, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addComponent(pinInfoLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 241, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(19, 19, 19))))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(versucheLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(pinHeaderLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pinInfoLabel)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(pinLabel)
                    .addComponent(pinPasswordField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(versucheLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(pinOkButton)
                    .addComponent(pinAbbruchButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void pinOkButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pinOkButtonActionPerformed
        char[] pswdChars = this.pinPasswordField.getPassword();
        if (pswdChars.length >= 4) {
            String pswd = String.valueOf(this.pinPasswordField.getPassword());
            if (kum.verify(pswd)) {
                pinOK = true;
                this.dispose();
            } else {
                this.versucheLabel.setText(kum.getLastErrorString());
            }
        }
    }//GEN-LAST:event_pinOkButtonActionPerformed

    private void pinAbbruchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pinAbbruchButtonActionPerformed
        this.dispose();
    }//GEN-LAST:event_pinAbbruchButtonActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton pinAbbruchButton;
    private javax.swing.JLabel pinHeaderLabel1;
    private javax.swing.JLabel pinInfoLabel;
    private javax.swing.JLabel pinLabel;
    private javax.swing.JButton pinOkButton;
    private javax.swing.JPasswordField pinPasswordField;
    private javax.swing.JLabel versucheLabel;
    // End of variables declaration//GEN-END:variables
}
