//  File:        ProdIdProxy.java
//  Copyright:   Copyright (C) 2010 AL ENGINEERING AG. All rights reserved.
//  Website:     http://www.al-ag.de
//  Description:
//  Comments:
//  Last edit:   18.06.2013
//  Author:      AL ENGINEERING AG
//  E-mail:      info@al-ag.de
//
//   This file is part of d(((eti-API.
//
//   d(((eti-API is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   d(((eti-API is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; If not, see <http://www.gnu.org/licenses/> or
//   write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//   Boston, MA 02111-1307 USA.
package de.alag.eticket.ticketinfo;

import de.alag.vdv.ka.tlv.global.EfmProduktID;

/**
 *
 * @author Alexander Schuetz
 */
public class ProdIdProxy {
    public EfmProduktID prodId;
    
    public ProdIdProxy(EfmProduktID pid) {
        prodId = pid;
    }
    
    @Override
    public String toString() {
        if (prodId.getProduktNummer() != 0) {
            return prodId.toString(1);
        }
        return "Produkte der Organisation " + prodId.getOrganisationsName();
    }

    @Override
    public boolean equals(Object obj) {
        return prodId.equals(obj);
    }

    @Override
    public int hashCode() {
        return prodId.hashCode();
    }
    
    
}
