//  File:        TemplateEditor.java
//  Copyright:   Copyright (C) 2010 AL ENGINEERING AG. All rights reserved.
//  Website:     http://www.al-ag.de
//  Description:
//  Comments:
//  Last edit:   18.06.2013
//  Author:      AL ENGINEERING AG
//  E-mail:      info@al-ag.de
//
//   This file is part of d(((eti-API.
//
//   d(((eti-API is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   d(((eti-API is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; If not, see <http://www.gnu.org/licenses/> or
//   write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//   Boston, MA 02111-1307 USA.
package de.alag.eticket.ticketinfo;

import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import de.alag.vdv.ka.tlv.Template;
import de.alag.vdv.ka.tlv.global.EfmProduktID;

/**
 *
 * @author Alexander Schuetz
 */
public class TemplateEditor extends javax.swing.JDialog {

    private DefaultListModel lm = new DefaultListModel();
    /**
     * Creates new form TemplateEditor
     */
    public TemplateEditor(java.awt.Frame parent, boolean modal, Template template) {
        super(parent, modal);
        initComponents();
        this.template = template;
        if (this.template != null) {
            this.TemplateLabel.setText("Template: " + this.template.getTemplateName());
        }
        refreshList();
    }

    private void refreshList() {
        DefaultListModel lm = new DefaultListModel();
        if (template != null) {
            for (EfmProduktID prodId : template.getProducts()) {
                lm.addElement(new ProdIdProxy(prodId));
            }
        }
        jList1.setModel(lm);
    }
    
    private Template template;

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        prodNr = new javax.swing.JTextField();
        orgId = new javax.swing.JTextField();
        addButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        PNrLabel = new javax.swing.JLabel();
        OrgLabel = new javax.swing.JLabel();
        TemplateLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        addButton.setText("Hinzufügen");
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        deleteButton.setText("Löschen");
        deleteButton.setEnabled(false);
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jList1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jList1ValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(jList1);

        PNrLabel.setText("Prod.-Nr.:");

        OrgLabel.setText("Org.-ID:");

        TemplateLabel.setText("Template: ");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(TemplateLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(OrgLabel, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(PNrLabel, javax.swing.GroupLayout.Alignment.TRAILING))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(prodNr, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(orgId, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(addButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(deleteButton, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 185, Short.MAX_VALUE))
                    .addComponent(jScrollPane2))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(TemplateLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 223, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(prodNr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(PNrLabel)
                    .addComponent(addButton)
                    .addComponent(deleteButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(orgId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(OrgLabel))
                .addContainerGap(20, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed
        Integer pNr = null;
        try {
            if (prodNr.getText().trim().isEmpty()) {
                pNr = 0;
            } else {
                pNr = Integer.parseInt(prodNr.getText());
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this,
                    prodNr.getText() + " ist keine gültige Nummer!",
                    "Achtung",
                    JOptionPane.WARNING_MESSAGE);
            return;
        }
        if (pNr == null) {
            pNr = 0;
        }
        if (pNr < 0 || pNr > 0xFFFF) {
            JOptionPane.showMessageDialog(this,
                    prodNr.getText() + " ist außerhalb des Wertebreichs für Produktnummern!",
                    "Achtung",
                    JOptionPane.WARNING_MESSAGE);
            return;
        }
        Integer org = null;
        try {
            org = Integer.parseInt(orgId.getText());
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this,
                    orgId.getText() + " ist keine gültige Nummer!",
                    "Achtung",
                    JOptionPane.WARNING_MESSAGE);
            return;
        }
        if (org == null) {
            JOptionPane.showMessageDialog(this,
                    "Es muss mindestens eine Organisation angegeben werden!",
                    "Achtung",
                    JOptionPane.WARNING_MESSAGE);
            return;
        }
        if (org <= 0 || org > 0xFFFF) {
            JOptionPane.showMessageDialog(this,
                    orgId.getText() + " ist außerhalb des Wertebreichs für Produktnummern!",
                    "Achtung",
                    JOptionPane.WARNING_MESSAGE);
            return;
        }
        template.add(new EfmProduktID(pNr.intValue(), org.intValue()));
        refreshList();
    }//GEN-LAST:event_addButtonActionPerformed

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        try {
            Object selection = jList1.getSelectedValue();
            if (selection == null) {
                return;
            }
            ProdIdProxy proxy = (ProdIdProxy)selection;
            template.remove(proxy.prodId);
            refreshList();
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this,
                    "Die Zuordnung konnte nicht gelöscht werden!",
                    "Achtung",
                    JOptionPane.WARNING_MESSAGE);
//                LOGGER.log(Level.SEVERE, "Fehler beim löschen der Zuordnung: {0}", ex.getMessage());
        }
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void jList1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jList1ValueChanged
        deleteButton.setEnabled(!jList1.isSelectionEmpty());
    }//GEN-LAST:event_jList1ValueChanged


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel OrgLabel;
    private javax.swing.JLabel PNrLabel;
    private javax.swing.JLabel TemplateLabel;
    private javax.swing.JButton addButton;
    private javax.swing.JButton deleteButton;
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextField orgId;
    private javax.swing.JTextField prodNr;
    // End of variables declaration//GEN-END:variables
}
