//  File:        TicketinfoHelp.java
//  Copyright:   Copyright (C) 2010 AL ENGINEERING AG. All rights reserved.
//  Website:     http://www.al-ag.de
//  Description:
//  Comments:
//  Last edit:   18.06.2013
//  Author:      AL ENGINEERING AG
//  E-mail:      info@al-ag.de
//
//   This file is part of d(((eti-API.
//
//   d(((eti-API is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   d(((eti-API is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; If not, see <http://www.gnu.org/licenses/> or
//   write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//   Boston, MA 02111-1307 USA.
package de.alag.eticket.ticketinfo;

import de.alag.util.FileLogManager;
import javax.help.JHelp;
import javax.help.HelpSet;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;

/**
 * Help des Viewers.
 * @author Frank Hamm
 */
public class TicketinfoHelp {

    /**
     * Der globale @see java.util.logging.Logger Logger für diese Klasse.
     */
    private static final Logger LOGGER = Logger.getLogger(TicketinfoHelp.class.getName());

    /**
     * Konstuktor.
     */
    public TicketinfoHelp() {
        FileLogManager.getInstance().registerLogger(LOGGER);
    }

    /**
     * Initiert das Hilfe Fenster.
     * @return Ob erfolgreich oder nicht.
     */
    public boolean initHelpView() {
        JHelp helpViewer;
        try {
            //ClassLoader cl = this.getClass().getClassLoader();
            URL helpSetURL = HelpSet.findHelpSet(getClass().getClassLoader(), "jhelpset.hs");
            helpViewer = new JHelp(new HelpSet(getClass().getClassLoader(), helpSetURL));
            helpViewer.setCurrentID("start");
        } catch (Exception ex) {
            LOGGER.severe("Fehler beim Aufbau des Help Windows");
            LOGGER.log(Level.FINE, null, ex);
            return false;
        }

        JFrame frame = new JFrame();
        frame.setTitle("Hilfe zu Ticketinfo");
        frame.setSize(800,600);
        frame.getContentPane().add(helpViewer);
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        frame.setVisible(true);
        return true;
    }

}
