//  File:        MultiSelectTable.java
//  Copyright:   Copyright (C) 2010 AL ENGINEERING AG. All rights reserved.
//  Website:     http://www.al-ag.de
//  Description:
//  Comments:
//  Last edit:   18.06.2013
//  Author:      AL ENGINEERING AG
//  E-mail:      info@al-ag.de
//
//   This file is part of d(((eti-API.
//
//   d(((eti-API is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   d(((eti-API is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; If not, see <http://www.gnu.org/licenses/> or
//   write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//   Boston, MA 02111-1307 USA.
package de.alag.eticket.ticketinfo.helpers;

import javax.swing.JTable;

/**
 *
 * @author Alexander Schuetz
 */
public class MultiSelectTable extends JTable {
    
    private boolean selectEnabled = false;
    private int groupIdx = -1;

    public int getGroupIdx() {
        return groupIdx;
    }

    public boolean isSelectEnabled() {
        return selectEnabled;
    }

    public void setSelectEnabled(boolean selectEnabled) {
        this.selectEnabled = selectEnabled;
        if (!this.selectEnabled) {
            groupIdx = -1;
        }
    }

    
    @Override
    public void changeSelection(int rowIndex, int columnIndex, boolean toggle, boolean extend) {
        if (selectEnabled) {
            int first = rowIndex;
            int last = rowIndex + 1;
            this.clearSelection();
            for (; first>=0; --first) {
                if (this.getValueAt(first, 1) == null) {
                    break;
                }
            }
            groupIdx = 0;
            for (int idx = first-1; idx>=0; --idx) {
                if (this.getValueAt(idx, 1) == null) {
                    ++groupIdx;
                }
            }
            
            for (; last<this.getRowCount(); ++last) {
                if (this.getValueAt(last, 1) == null) {
                    break;
                }
            }
            --last;
            super.changeSelection(first, 0, false, false);
            super.changeSelection(last, 0, false, true);
        }
    }
}
