/*
 *   Copyright (C) <2010>  <AL-ENGINEERING AG>
 *   written by Hans-Joachim Haas
 *   Email <info@al-ag.de>
 *
 *   d(((eti-API is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   d(((eti-API is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this library; if not, write to the Free Software Foundation,
 *   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package de.alag.eticket.ticketinfo.professional;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import de.alag.vdv.ka.tlv.entitlement.SeparateDatenBerechtigung;
import de.alag.vdv.ka.xml.NmBerechtigungsdatenType;

/**
 * Repräsentiert eine Bechrechtigung
 * @author Hans-Joachim Haas
 */
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class NMBerechtigung {

    @XmlTransient
    SeparateDatenBerechtigung sepDat;
    protected NmBerechtigungsdatenType separateDatenBerechtigung;
    protected String FehlerVDVKA;
    protected String FehlerTarif;
    protected String FehlerVergleich;
    protected String Freitext;

    /**
     * Konstruktor
     */
    public NMBerechtigung() {
    }

    /**
     * Konstruktor
     * @param dat Berechtigungsdaten
     */
    public NMBerechtigung(SeparateDatenBerechtigung dat) {
        sepDat = dat;
        separateDatenBerechtigung = sepDat.getXml(true);
    }

    /**
     * setzt den Text für FehlerVDVKA
     * @param txt 
     */
    public void setFehlerVDVKA(String txt) {
        FehlerVDVKA = txt;
    }

    /**
     * Setzt den Text für Fehler im Tarif
     * @param txt 
     */
    public void setFehlerTarif(String txt) {
        FehlerTarif = txt;
    }

    /**
     * Setzt den Text bei Fehler beim Vergleichen
     * @param txt 
     */
    public void setFehlerVergleich(String txt) {
        FehlerVergleich = txt;
    }

    /**
     * Setzt den Freitext
     * @param txt 
     */
    public void setFreiText(String txt) {
        Freitext = txt;
    }
}
