/*
 *   Copyright (C) <2010>  <AL-ENGINEERING AG>
 *   written by Hans-Joachim Haas
 *   Email <info@al-ag.de>
 *
 *   d(((eti-API is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   d(((eti-API is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this library; if not, write to the Free Software Foundation,
 *   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package de.alag.eticket.ticketinfo.professional;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSeeAlso;

/**
 *
 * @author Hans-Joachim Haas
 */
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
@XmlSeeAlso(
        {
            Nutzermedium.class
            //,Applikationsverzeichnis.class
        })
/**
 * Repräsentiert eine Liste von Nutzermedien
 */
public class NutzermediumListe {
    
    @XmlAnyElement
    protected List<Nutzermedium> NMListe;

    public NutzermediumListe() {
        NMListe = new ArrayList<Nutzermedium>();
    }
            
    /**
     * Fügt ein neues Nutermedium hinzu
     * @param Nutzermedium
     */
    public void Add(Nutzermedium m) {
        NMListe.add(m);
    }
    
    /**
     * Gibt die Anzahl der Nutzermedien zurück
     * @return Anzahl int
     */
    public int getAnzahl() {
        return NMListe.size();
    }
    
    /**
     * Gibt das letzte Element zurück
     * @return Nutzermedium
     */
    public Nutzermedium LetztesElement () {
        return NMListe.get(NMListe.size() - 1);
    }
            
    /**
     * Git eine Nutzermeduim an einer bestimmten Stelle zurück
     * @param Pos
     * @return Nutzermedium
     */
    public Nutzermedium getElement(int i) {
        return NMListe.get(i-1);
    }
    
}