/*
 *   Copyright (C) <2010>  <AL-ENGINEERING AG>
 *   written by Hans-Joachim Haas
 *   Email <info@al-ag.de>
 *
 *   d(((eti-API is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   d(((eti-API is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this library; if not, write to the Free Software Foundation,
 *   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/*
 * OptionDialog.java
 *
 * Created on 26.09.2011, 10:19:20
 */
package de.alag.eticket.ticketinfo.professional;

import de.alag.eticket.ticketinfo.Ticketinfo;
import java.io.File;
import java.util.Properties;
import javax.swing.JFileChooser;

/**
 * Dialog zur Festlegung der Einstellungen
 * @author Hans-Joachim Haas
 */
public class OptionDialog extends javax.swing.JDialog {

    private Properties propertiy;
    private boolean isOK = false;
    
    /** Creates new form OptionDialog */
    public OptionDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTextField6 = new javax.swing.JTextField();
        jTextField7 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jButton3 = new javax.swing.JButton();
        jTextField5 = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jTextField4 = new javax.swing.JTextField();
        jCheckBox1 = new javax.swing.JCheckBox();
        jLabel5 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jCheckBox3 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jTextField1 = new javax.swing.JTextField();
        jTextField8 = new javax.swing.JTextField();
        jCheckBox4 = new javax.swing.JCheckBox();
        jCheckBox5 = new javax.swing.JCheckBox();
        jLabel6 = new javax.swing.JLabel();
        jCheckBox6 = new javax.swing.JCheckBox();
        jCheckBox7 = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jTextField6.setText("-");
        jTextField6.setName("jTextField6"); // NOI18N

        jTextField7.setText("3");
        jTextField7.setName("jTextField7"); // NOI18N

        jLabel4.setText("Stellen:");
        jLabel4.setName("jLabel4"); // NOI18N

        jButton3.setText("...");
        jButton3.setName("jButton3"); // NOI18N
        jButton3.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jTextField5.setText("2");
        jTextField5.setName("jTextField5"); // NOI18N

        jButton1.setText("OK");
        jButton1.setName("jButton1"); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Abbrechen");
        jButton2.setMaximumSize(new java.awt.Dimension(49, 25));
        jButton2.setMinimumSize(new java.awt.Dimension(49, 25));
        jButton2.setName("jButton2"); // NOI18N
        jButton2.setPreferredSize(new java.awt.Dimension(49, 25));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel3.setText("Pfad:");
        jLabel3.setName("jLabel3"); // NOI18N

        jTextField4.setEditable(false);
        jTextField4.setText("/tmp");
        jTextField4.setName("jTextField4"); // NOI18N

        jCheckBox1.setText("Alle Daten in einer einzigen Datei");
        jCheckBox1.setName("jCheckBox1"); // NOI18N

        jLabel5.setText("Trennzeichen:");
        jLabel5.setName("jLabel5"); // NOI18N

        jTextField3.setText("Berechtigung");
        jTextField3.setName("jTextField3"); // NOI18N

        jLabel2.setText("Präfix:");
        jLabel2.setName("jLabel2"); // NOI18N

        jCheckBox3.setText("Eine Datei pro Berechtigung");
        jCheckBox3.setName("jCheckBox3"); // NOI18N

        jCheckBox2.setText("Eine Datei pro Nutzermedium");
        jCheckBox2.setName("jCheckBox2"); // NOI18N

        jLabel1.setText("Datei speichern:");
        jLabel1.setName("jLabel1"); // NOI18N

        jTextField2.setText("Karte");
        jTextField2.setName("jTextField2"); // NOI18N

        jTextField1.setText("NMListe");
        jTextField1.setName("jTextField1"); // NOI18N

        jTextField8.setName("jTextField8"); // NOI18N

        jCheckBox4.setText("Ton ein");
        jCheckBox4.setName("jCheckBox4"); // NOI18N

        jCheckBox5.setText("Fehler nach VDVKA-Spezifikation");
        jCheckBox5.setName("jCheckBox5"); // NOI18N

        jLabel6.setText("Fehler-Protokollierung:");
        jLabel6.setName("jLabel6"); // NOI18N

        jCheckBox6.setText("Fehler tariflicher Art");
        jCheckBox6.setName("jCheckBox6"); // NOI18N

        jCheckBox7.setText("Fehler beim Vergleichen der Berechtigungen");
        jCheckBox7.setName("jCheckBox7"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jCheckBox7)
                        .addContainerGap())
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                            .addComponent(jCheckBox6)
                            .addContainerGap())
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jCheckBox5)
                                .addContainerGap())
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(layout.createSequentialGroup()
                                    .addComponent(jLabel6)
                                    .addContainerGap())
                                .addGroup(layout.createSequentialGroup()
                                    .addComponent(jCheckBox4)
                                    .addContainerGap())
                                .addGroup(layout.createSequentialGroup()
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(layout.createSequentialGroup()
                                            .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 269, Short.MAX_VALUE)
                                            .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(layout.createSequentialGroup()
                                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                .addGroup(layout.createSequentialGroup()
                                                    .addComponent(jLabel3)
                                                    .addGap(18, 18, 18)
                                                    .addComponent(jTextField4, javax.swing.GroupLayout.PREFERRED_SIZE, 259, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addGap(18, 18, 18)
                                                    .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                .addGroup(layout.createSequentialGroup()
                                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addComponent(jCheckBox1)
                                                        .addComponent(jCheckBox3)
                                                        .addComponent(jCheckBox2)
                                                        .addComponent(jLabel1))
                                                    .addGap(48, 48, 48)
                                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                                        .addComponent(jTextField3)
                                                        .addComponent(jTextField1, javax.swing.GroupLayout.DEFAULT_SIZE, 124, Short.MAX_VALUE)
                                                        .addComponent(jLabel2)
                                                        .addComponent(jTextField2))))
                                            .addGap(18, 18, 18)
                                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, 49, Short.MAX_VALUE)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                                    .addComponent(jTextField5, javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addComponent(jTextField7, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                .addComponent(jTextField8, javax.swing.GroupLayout.DEFAULT_SIZE, 68, Short.MAX_VALUE)
                                                .addComponent(jTextField6, javax.swing.GroupLayout.DEFAULT_SIZE, 68, Short.MAX_VALUE))))
                                    .addGap(19, 19, 19)))))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel2)
                            .addComponent(jLabel1)
                            .addComponent(jLabel4)
                            .addComponent(jLabel5))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jCheckBox1)
                            .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(6, 6, 6)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jCheckBox2)
                            .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jCheckBox3)
                            .addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                            .addGap(95, 95, 95)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jTextField5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGroup(layout.createSequentialGroup()
                            .addGap(58, 58, 58)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jTextField7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jTextField8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel3)
                        .addComponent(jTextField4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jCheckBox4)
                .addGap(18, 18, 18)
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBox5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBox6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBox7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 45, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(20, 20, 20))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * OK-Knopf
     * @param evt 
     */
private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.einzelneDatei, this.jCheckBox1.isSelected());
    
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.einzelneNM, this.jCheckBox2.isSelected());
        
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.einzelneBer, this.jCheckBox1.isSelected());
        
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.PraefixDatei, this.jTextField1.getText());
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.PraefixNM, this.jTextField2.getText());
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.PraefixBer, this.jTextField3.getText());
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.StellenNM, this.jTextField7.getText());
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.StellenBer, this.jTextField5.getText());
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.Trennzeichen1, this.jTextField8.getText());
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.Trennzeichen2, this.jTextField6.getText());
    if(!this.jTextField4.getText().endsWith(File.separator)) {
        this.jTextField4.setText(this.jTextField4.getText() + File.separator);
    }
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.Pfad, this.jTextField4.getText());
    
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.Ton, this.jCheckBox4.isSelected());
    
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.FehlerVDVKA, this.jCheckBox5.isSelected());
    
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.FehlerTarif, this.jCheckBox6.isSelected());
    
    Ticketinfo.setConfig(propertiy, Ticketinfo.CONFIG.FehlerVergleich, this.jCheckBox7.isSelected());
    
    isOK = true;
    setVisible(false);
}//GEN-LAST:event_jButton1ActionPerformed

/**
 * Abbrechen
 * @param evt 
 */
private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    isOK = false;
    this.setVisible(false );
}//GEN-LAST:event_jButton2ActionPerformed

/**
 * Pfad suchen
 * @param evt 
 */
private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
JFileChooser fc = new JFileChooser();
fc.accept(null);
fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
if(fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION){
    jTextField4.setText(fc.getSelectedFile().getAbsolutePath());
};
}//GEN-LAST:event_jButton3ActionPerformed

/*
 * Properties übergeben
 */
public void setProperties(Properties aProperty){
        propertiy = aProperty;
        
        this.jCheckBox1.setSelected(Ticketinfo.getConfigBoolean(propertiy, Ticketinfo.CONFIG.einzelneDatei));
        this.jCheckBox2.setSelected(Ticketinfo.getConfigBoolean(propertiy, Ticketinfo.CONFIG.einzelneNM));
        this.jCheckBox3.setSelected(Ticketinfo.getConfigBoolean(propertiy, Ticketinfo.CONFIG.einzelneBer));
        
        this.jTextField1.setText(Ticketinfo.getConfig(propertiy, Ticketinfo.CONFIG.PraefixDatei));
        this.jTextField2.setText(Ticketinfo.getConfig(propertiy, Ticketinfo.CONFIG.PraefixNM));
        this.jTextField3.setText(Ticketinfo.getConfig(propertiy, Ticketinfo.CONFIG.PraefixBer));
        
        this.jTextField7.setText(Ticketinfo.getConfig(propertiy, Ticketinfo.CONFIG.StellenNM));
        this.jTextField5.setText(Ticketinfo.getConfig(propertiy, Ticketinfo.CONFIG.StellenBer));
        this.jTextField8.setText(Ticketinfo.getConfig(propertiy, Ticketinfo.CONFIG.Trennzeichen1));
        this.jTextField6.setText(Ticketinfo.getConfig(propertiy, Ticketinfo.CONFIG.Trennzeichen2));
        
        this.jTextField4.setText( propertiy.getProperty("Pfad"));
        
        this.jCheckBox4.setSelected(Ticketinfo.getConfigBoolean(propertiy, Ticketinfo.CONFIG.Ton));
        
        this.jCheckBox5.setSelected(Ticketinfo.getConfigBoolean(propertiy, Ticketinfo.CONFIG.FehlerVDVKA));
        this.jCheckBox6.setSelected(Ticketinfo.getConfigBoolean(propertiy, Ticketinfo.CONFIG.FehlerTarif));
        this.jCheckBox7.setSelected(Ticketinfo.getConfigBoolean(propertiy, Ticketinfo.CONFIG.FehlerVergleich));
    }

    public Properties getProperties(){
        return propertiy;
    }
    
    public boolean getOK(){
        return isOK;
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(OptionDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(OptionDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(OptionDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(OptionDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                OptionDialog dialog = new OptionDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JCheckBox jCheckBox6;
    private javax.swing.JCheckBox jCheckBox7;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    private javax.swing.JTextField jTextField8;
    // End of variables declaration//GEN-END:variables
}
