/*
 *   Copyright (C) <2010>  <AL-ENGINEERING AG>
 *   written by Hans-Joachim Haas
 *   Email <info@al-ag.de>
 *
 *   d(((eti-API is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   d(((eti-API is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this library; if not, write to the Free Software Foundation,
 *   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package de.alag.eticket.ticketinfo.professional;

import de.alag.util.nfc.ISmartcard;

/**
 * Wartet bis die Karte vom Leser genommen wird
 * @author Hans-Joachim Haas
 */
public class WaitForCardThread extends Thread {

    private ISmartcard scconnection;
    private boolean status;
    
    public WaitForCardThread(ISmartcard scc) {
        scconnection = scc;
        status = true;
    }
    
    /**
     * Run von Thread 
     */
    @Override
    public void run() {
        status = false; 
        try {
            scconnection.waitForCard(0);
        }
        catch(Exception ex){
            
        }
        
        status = true;
        
    }
    
    public boolean getStatus() {
        return status;
    }
    
    public void setStatus(boolean value) {
        status = value;
    }

    
}
